/*
 * Copyright (C) 2022 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
package de.ozgcloud.nachrichten.postfach.osi;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Configuration;

import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
@Configuration
@ConfigurationProperties(prefix = OsiPostfachProperties.PROXY_API_PREFIX)
public class OsiPostfachProperties {

	static final String PREFIX = "ozgcloud.osi.postfach";
	static final String PROXY_API_PREFIX = PREFIX + ".proxyapi";

	private String url;
	private String key;
	private String realm;

	@Autowired
	private ProxyConfiguration proxyConfiguration;

	@Getter
	@Setter
	@Configuration
	@ConfigurationProperties(prefix = ProxyConfiguration.PREFIX)
	static class ProxyConfiguration {
		static final String PREFIX = OsiPostfachProperties.PREFIX + ".http-proxy";

		private String host;
		private Integer port;

		private boolean authenticationRequired;
		private String username;
		private String password;
	}
}
